unit KA.Data.Ado.SASUnit;
interface

uses
  System.Text,
  System.Reflection,
  Borland.Vcl.Windows,
  Borland.Vcl.SysUtils,
  Borland.Vcl.Classes,
  Borland.Vcl.Graphics,
  Borland.Vcl.Controls,
  Borland.Vcl.Forms,
  Borland.Vcl.Dialogs,
  Borland.Vcl.DB,
  Borland.Vcl.AdoDB,
  Borland.Vcl.DBGrids,
  Borland.Vcl.StdCtrls,
  Borland.Vcl.ExtCtrls,
  Borland.Vcl.CheckLst,
  Borland.Vcl.Variants,
  KA.Data.Ado.HRollForm,
  System.ComponentModel;

type
  TSAS = class(TForm)
    Label1: TLabel;                                         
    ListBox1: TListBox;
    Button2: TButton;
    Button1: TButton;
    GroupBox1: TGroupBox;
    SaveDialog1: TSaveDialog;
    CheckBox2: TCheckBox;
    GroupBox2: TGroupBox;
    CheckBox3: TCheckBox;
    Label3: TLabel;
    ComboBox1: TComboBox;
    Label4: TLabel;
    ComboBox2: TComboBox;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label5: TLabel;
    Edit3: TEdit;
    KAHRollForm1: TAdoHRollForm;
    GroupBox3: TGroupBox;
    CheckListBox1: TCheckListBox;
    procedure ListBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
  private
    { Private declarations }
    Table : TAdoTable;
    Grid  : TDBGrid;
    procedure WriteSchemaIni(FN:String);
    Function  StoreField(X:Integer): Boolean;
    Procedure AccessExportToTXT(FileName:String; DeleteOld:Boolean);
    Procedure AccessExportToHTML(FileName:String; DeleteOld:Boolean);
    Procedure AccessExportToExcel(FileName, SheetName :String; ExcelVersion:Integer; DeleteOld:Boolean);
    Procedure AccessExportToParadox(FileName:String; ParadoxVersion:Integer; DeleteOld:Boolean);
    Procedure AccessExportToDBase(FileName:String; DBaseVersion:Integer; DeleteOld:Boolean);
    Procedure AccessExportToMDB(FileName,NewTableName:String; DeleteOld:Boolean);
    Procedure SaveToADTG(const FileName: String; DeleteExisting:Boolean);
    Procedure SaveToXML(const FileName: String; DeleteExisting:Boolean);

    Function  CreateAccessDatabaseEx(DatabaseName, Language, DatabasePassword, Version: String; Encrypt: Boolean):Boolean;
    Function  CreateAccessDatabase(DatabaseName: String):Boolean;

    Function  EscapeSpecialCharacters(Const S:String):String;
    Function  BracketField (const FieldName:String) : String;
    Function  FindColumn(Caption:String):TColumn;
    Function  FindCaption(Caption:String):TField;
    procedure DoExport;
  public
    { Public declarations }
    ExportDir     : String;
    UseBrackets   : Boolean;
    BracketClose  : String;
    BracketOpen   : String;
    Function Execute(AdoTable : TDataset):Boolean;
    Function ExecutefromGrid(AdoTable : TDataset; AdoGrid: TDBGrid):Boolean;
  end;

var
  SAS: TSAS;

implementation
{$R *.nfm}

Function TSAS.EscapeSpecialCharacters(Const S:String):String;
Var
 X, L : Integer;
Begin
 Result := '';
 L      := Length(S);
 if L    = 0 Then Exit;
 For X := 1 To L do
     Begin
       if (S[X]='"')  Then Result := Result+'"';
       if (S[X]='''') Then Result := Result+'''';
       if (S[X]='*')
       Or (S[X]='?')
       Or (S[X]='#')
       Or (S[X]='[')
       Or (S[X]=']')
       Or (S[X]='!')
       Or (S[X]='-')  Then Result := Result+'[';
       Result := Result+S[X];
       if (S[X]='*')
       Or (S[X]='?')
       Or (S[X]='#')
       Or (S[X]='[')
       Or (S[X]=']')
       Or (S[X]='!')
       Or (S[X]='-')  Then Result := Result+']';
     End;
End;


Function TSAS.BracketField (const FieldName:String) : String;
Var
  P : Integer;
  S : String;
Begin
  Result := '';
  if UseBrackets Then
     Begin
       S := FieldName;
       P := Pos('.',S);
       While P > 0 Do
         Begin
           Result := Result+EscapeSpecialCharacters(Borland.Delphi.System.Copy(S,1,P-1));
           Result := BracketClose+Result+'.'+BracketOpen;
           Borland.Delphi.System.Delete(S,1,P);
           P := Pos('.',S);
         End;
       Result := BracketOpen+Result+EscapeSpecialCharacters(S)+BracketClose;
     End
  Else
     Begin
       Result := FieldName;
     End;
End;

Function  TSAS.FindColumn(Caption:String):TColumn;
Var
 X : Integer;
Begin
 Result := Nil;
 For X := 0 To Grid.Columns.Count-1 do
     Begin
       If (Grid.Columns.Items[X].Title.Caption=Caption) Then
          Begin
            Result := Grid.Columns.Items[X];
            Exit;
          End;
     End;
End;


Function  TSAS.FindCaption(Caption:String):TField;
Var
 X : Integer;
Begin
 Result := Nil;
 For X := 0 To Table.FieldCount-1 do
     Begin
       if  (Table.Fields[X].Visible)
       And (Table.Fields[X].DisplayLabel=Caption) Then
          Begin
            Result := Table.Fields[X];
          End;
     End;
End;

Function TSAS.Execute(AdoTable : TDataset):Boolean;
Var
 X : Integer;
Begin
 Result        := False;
 Table  := TAdoTable(AdoTable);
 Grid   := Nil;
 ListBox1.Clear;
 ListBox1.Items.Add('MS Excel 3.0');
 ListBox1.Items.Add('MS Excel 4.0');
 ListBox1.Items.Add('MS Excel 5.0');
 ListBox1.Items.Add('MS Excel 8.0');

 ListBox1.Items.Add('Paradox 3.X');
 ListBox1.Items.Add('Paradox 4.X');
 ListBox1.Items.Add('Paradox 5.X');
 ListBox1.Items.Add('Paradox 7.X');
 ListBox1.Items.Add('dBase III');
 ListBox1.Items.Add('dBase IV');
 ListBox1.Items.Add('dBase 5.0');

 ListBox1.Items.Add('HTML');
 ListBox1.Items.Add('Text');
 ListBox1.Items.Add('MS Access');

 ListBox1.Items.Add('XML');
 ListBox1.Items.Add('ADTG');
 ListBox1.ItemIndex:=0;

 ComboBox1.Clear;
 ComboBox1.Items.Add('ANSI');
 ComboBox1.Items.Add('OEM');
 ComboBox1.Items.Add(IntToStr(GetACP));
 ComboBox1.Items.Add(IntToStr(GetOEMCP));
 ComboBox1.ItemIndex:=0;

 ComboBox2.Clear;
 ComboBox2.Items.Add('Semicolon Delimited');
 ComboBox2.Items.Add('Tab Delimited');
 ComboBox2.Items.Add('CSV Delimited');
 ComboBox2.Items.Add('Fixed Length');
 ComboBox2.ItemIndex:=0;

 CheckListBox1.Clear;
 For X := 0 to AdoTable.FieldCount-1 do
     Begin
       if AdoTable.Fields[X].Visible Then
          Begin
            CheckListBox1.Items.Add(AdoTable.Fields[X].DisplayLabel);
            CheckListBox1.Checked[CheckListBox1.Items.Count-1]:=True;
          End;
     End;
 KAHRollForm1.Enabled := True;
 ShowModal;
 if ModalResult=mrOK Then Result := True;
End;

Function TSAS.ExecutefromGrid(AdoTable : TDataset; AdoGrid: TDBGrid):Boolean;
Var
 X : Integer;
Begin
 Result := False;
 Table  := TAdoTable(AdoTable);
 Grid   := AdoGrid;
 ListBox1.Clear;
 ListBox1.Items.Add('MS Excel 3.0');
 ListBox1.Items.Add('MS Excel 4.0');
 ListBox1.Items.Add('MS Excel 5.0');
 ListBox1.Items.Add('MS Excel 8.0');

 ListBox1.Items.Add('Paradox 3.X');
 ListBox1.Items.Add('Paradox 4.X');
 ListBox1.Items.Add('Paradox 5.X');
 ListBox1.Items.Add('Paradox 7.X');
 ListBox1.Items.Add('dBase III');
 ListBox1.Items.Add('dBase IV');
 ListBox1.Items.Add('dBase 5.0');

 ListBox1.Items.Add('HTML');
 ListBox1.Items.Add('Text');
 ListBox1.Items.Add('MS Access');

 ListBox1.Items.Add('XML');
 ListBox1.Items.Add('ADTG');
 ListBox1.ItemIndex:=0;

 ComboBox1.Clear;
 ComboBox1.Items.Add('ANSI');
 ComboBox1.Items.Add('OEM');
 ComboBox1.Items.Add(IntToStr(GetACP));
 ComboBox1.Items.Add(IntToStr(GetOEMCP));
 ComboBox1.ItemIndex:=0;

 ComboBox2.Clear;
 ComboBox2.Items.Add('Semicolon Delimited');
 ComboBox2.Items.Add('Tab Delimited');
 ComboBox2.Items.Add('CSV Delimited');
 ComboBox2.Items.Add('Fixed Length');
 ComboBox2.ItemIndex:=0;

 CheckListBox1.Clear;
 For X := 0 to Grid.Columns.Count-1 do
     Begin
       CheckListBox1.Items.Add(Grid.Columns[X].Title.Caption);
       if Grid.Columns[X].Visible Then
          CheckListBox1.Checked[CheckListBox1.Items.Count-1]:=True;
     End;
 KAHRollForm1.Enabled := True;
 ShowModal;
 if ModalResult=mrOK Then Result := True;
End;



procedure TSAS.ListBox1Click(Sender: TObject);
begin
  Label2.Enabled    := False;
  Edit2.Enabled     := False;
  Label5.Enabled    := False;
  Edit3.Enabled     := False;

  Label3.Enabled    := False;
  Label4.Enabled    := False;
  CheckBox3.Enabled := False;
  GroupBox2.Enabled := False;
  ComboBox1.Enabled := False;
  ComboBox2.Enabled := False;
  if (ListBox1.ItemIndex > -1) And (ListBox1.ItemIndex < 4) Then
     Begin
       Label2.Enabled := True;
       Edit2.Enabled  := True;
     End;
  if (ListBox1.ItemIndex = 13) Then
     Begin
       Label5.Enabled := True;
       Edit3.Enabled  := True;
     End;
  if (ListBox1.ItemIndex=11) Or (ListBox1.ItemIndex=12) Then
     Begin
      Label3.Enabled    := True;
      Label4.Enabled    := True;
      ComboBox1.Enabled := True;
      ComboBox2.Enabled := True;
      CheckBox3.Enabled := True;
      GroupBox2.Enabled := True;
     End;
end;

procedure TSAS.WriteSchemaIni(FN:String);
var
 IniFN       : String;
 IniSection  : String;
 II          : Integer;
 Format      : String;
 X           : Integer;
 Col         : String;
 Tmp         : StringBuilder;
 S           : String;
Begin
 IniFN       := ExtractFilePath(FN)+'schema.ini';
 IniSection  := ExtractFileName(FN);
 II          := ComboBox2.ItemIndex;
 if ListBox1.ItemIndex=11 Then II:=4;
 Case II of
    0 : Format := 'Delimited(;)';
    1 : Format := 'TabDelimited';
    2 : Format := 'CSVDelimited';
    3 : Format := 'FixedLength';
    4 : Format := 'HTML';
 End;
 if CheckBox3.Checked Then
    WritePrivateProfileString(IniSection,'ColNameHeader','True',IniFN)
 Else
    WritePrivateProfileString(IniSection,'ColNameHeader','False',IniFN);
 WritePrivateProfileString(IniSection,'MaxScanRows','0',IniFN);
 WritePrivateProfileString(IniSection,'Format',Format,IniFN);
 WritePrivateProfileString(IniSection,'CharacterSet',ComboBox1.Items[ComboBox1.ItemIndex],IniFN);

 Tmp := StringBuilder.Create(1000);
 if II=3 Then
    Begin
      For X := 0 to Table.FieldCount-1 do
          Begin
            Col := 'Col'+IntToStr(X+1);
            GetPrivateProfileString(IniSection,Col,'',Tmp,1000,IniFN);
            S := Tmp.ToString;
            if S <> '' Then
               Begin
                 if Pos('width ',WideLowerCase(S))=0 Then
                    Begin
                      S := S+' Width '+Edit1.Text;
                      WritePrivateProfileString(IniSection,Col,S,IniFN);
                    End;
               End;
          End;
    End;
  Tmp.Free;
End;

Function TSAS.StoreField(X:Integer): Boolean;
Begin
   Case Table.Fields[X].FieldKind of
        fkData       : Result := True;
        fkCalculated : Result := False;
        fkLookup     : Result := False;
   Else                Result := False;
   End;
   if NOT Table.Fields[X].Visible Then Result := False;
End;


Procedure TSAS.AccessExportToTXT(FileName:String; DeleteOld:Boolean);
Var
 SQL : TStringList;
 FN  : String;
 FP  : String;
 L   : Integer;
 SS  : String;
 X   : Integer;
 FC  : Integer;
 TN  : String;
 RA  : OleVariant;
Begin
 If Not Table.Active Then DatabaseError('Table must be open in order to export data!');
 TN := '';
 Try
 if (DeleteOld) And FileExists(FileName) Then DeleteFile(FileName);
 TN := Table.TableName;
 FN := ExtractFileName(FileName);
 FP := ExtractFilePath(FileName);
 if FP='' Then FP:='.';
 L  := Length(FN);
 If L=0 Then DatabaseError('FileName is empty!');
 For X :=1 To L do If FN[X]='.' Then FN[X]:='#';
 SS:='';
 FC := Table.FieldCount-1;
 For X := 0 To FC do
     Begin
      if StoreField(X) Then
       Begin
        if UseBrackets Then
          Begin
           SS := SS+' '+BracketField(Table.Fields[X].FieldName);
           if X < FC Then SS := SS+','
          End
        Else
          Begin
           if X < FC Then
              SS := SS+' '+Table.Fields[X].FieldName+','
           Else
              SS := SS+' '+Table.Fields[X].FieldName;
          End;
       End;
     End;
 if SS[Length(SS)]=',' Then Borland.Delphi.System.Delete(SS,Length(SS),1);
 SQL := TStringList.Create;
 Try
   SQL.Add(Format('Select %s INTO [%s] IN "%s"[Text;] FROM [%s]',[SS,FN,FP,TN]));
   if (Table.Filtered) And (Table.Filter <> '') Then SQL.Add(' WHERE '+Table.Filter);
   SQL.Add(';');
   Table.Connection.ConnectionObject.Execute(SQL.Text,RA,0)
 Finally
   SQL.Free;
 End;
 Finally
 End;
End;

Procedure TSAS.AccessExportToHTML(FileName:String; DeleteOld:Boolean);
Var
 SQL : TStringList;
 FN  : String;
 FP  : String;
 SS  : String;
 X   : Integer;
 FC  : Integer;
 TN  : String;
 RA  : OleVariant;
Begin
 If Not Table.Active Then DatabaseError('Table must be open in order to export data!');
 TN := '';
 Try
 if (DeleteOld) And FileExists(FileName) Then DeleteFile(FileName);
 TN := Table.TableName;
 FN := ExtractFileName(FileName);
 FP := ExtractFilePath(FileName);
 if FP='' Then FP:='.';
 SS:='';
 FC := Table.FieldCount-1;
 For X := 0 To FC do
     Begin
      if StoreField(X) Then
       Begin
        if UseBrackets Then
          Begin
           SS := SS+' '+BracketField(Table.Fields[X].FieldName);
           if X < FC Then SS := SS+','
          End
        Else
          Begin
           if X < FC Then
              SS := SS+' '+Table.Fields[X].FieldName+','
           Else
              SS := SS+' '+Table.Fields[X].FieldName;
          End;
       End;
     End;
 if SS[Length(SS)]=',' Then Borland.Delphi.System.Delete(SS,Length(SS),1);
 SQL := TStringList.Create;
 Try
   SQL.Add(Format('Select %s INTO [%s] IN "%s"[HTML Export;] FROM [%s]',[SS, FN,FP,TN]));
   if (Table.Filtered) And (Table.Filter <> '') Then SQL.Add(' WHERE '+Table.Filter);
   SQL.Add(';');
   Table.Connection.ConnectionObject.Execute(SQL.Text,RA,0)
 Finally
   SQL.Free;
 End;
 Finally
 End;
End;

Procedure TSAS.AccessExportToExcel(FileName, SheetName :String; ExcelVersion:Integer; DeleteOld:Boolean);
Var
 SQL : TStringList;
 EV  : String;
 SS  : String;
 X   : Integer;
 FC  : Integer;
 TN  : String;
 RA  : OleVariant;
Begin
 If Not Table.Active Then DatabaseError('Table must be open in order to export data!');
 TN := '';
 Try
 if (DeleteOld) And FileExists(FileName) Then DeleteFile(FileName);
 TN := Table.TableName;
 EV := 'Excel 8.0;';
 Case ExcelVersion of
      3 : EV := 'Excel 3.0;';
      4 : EV := 'Excel 4.0;';
      5 : EV := 'Excel 5.0;';
      8 : EV := 'Excel 8.0;';
 End;
 SS:='';
 FC := Table.FieldCount-1;
 For X := 0 To FC do
     Begin
       if (Table.Fields[X].DataType<>ftBlob) And (StoreField(X)) Then
          Begin
            if UseBrackets Then
               Begin
                SS := SS+' '+BracketField(Table.Fields[X].FieldName);
                if X < FC Then SS := SS+','
               End
            Else
               Begin
                if X < FC Then
                   SS := SS+' '+Table.Fields[X].FieldName+','
                Else
                   SS := SS+' '+Table.Fields[X].FieldName;
               End;
          End;
     End;
 if SS[Length(SS)]=',' Then Borland.Delphi.System.Delete(SS,Length(SS),1);
 SQL := TStringList.Create;
 Try
   SQL.Add(Format('Select %s INTO [%s] IN "%s"[%s] FROM [%s]',[SS,SheetName,FileName,EV,TN]));
   if (Table.Filtered) And (Table.Filter <> '') Then SQL.Add(' WHERE '+Table.Filter);
   SQL.Add(';');
   Table.Connection.ConnectionObject.Execute(SQL.Text,RA,0)
 Finally
   SQL.Free;
 End;
 Finally
 End;
End;

Procedure TSAS.AccessExportToParadox(FileName:String; ParadoxVersion:Integer; DeleteOld:Boolean);
Var
 SQL : TStringList;
 FN  : String;
 FP  : String;
 SS  : String;
 X   : Integer;
 FC  : Integer;
 PV  : String;
 P   : Integer;
 Res : Integer;
 Dir : TSearchRec;
 TN  : String;
 RA  : OleVariant;
Begin
 If Not Table.Active Then DatabaseError('Table must be open in order to export data!');
 TN := '';
 Try
 TN := Table.TableName;
 FN := ExtractFileName(FileName);
 FP := ExtractFilePath(FileName);
 if (DeleteOld) Then
    Begin
     P := FN.LastIndexOf('.');
     if P > -1 Then  FN := Borland.Delphi.System.Copy(FN,1,P);
     Res := Borland.Vcl.SysUtils.FindFirst(FP+FN+'.*',faArchive,Dir);
     While Res = 0 Do
       Begin
         DeleteFile(FP+Dir.Name);
         Res:= Borland.Vcl.SysUtils.FindNext(Dir);
       End;
     Borland.Vcl.SysUtils.FindClose(Dir);
    End;
 FN := ExtractFileName(FileName);
 if FP='' Then FP:='.';
 SS:='';
 FC := Table.FieldCount-1;
 For X := 0 To FC do
     Begin
      if StoreField(X) Then
       Begin
        if UseBrackets Then
          Begin
           SS := SS+' '+BracketField(Table.Fields[X].FieldName);
           if X < FC Then SS := SS+','
          End
        Else
          Begin
           if X < FC Then
              SS := SS+' '+Table.Fields[X].FieldName+','
           Else
              SS := SS+' '+Table.Fields[X].FieldName;
          End;
       End;
     End;
 Case ParadoxVersion of
      3 : PV := 'Paradox 3.X;';
      4 : PV := 'Paradox 4.X;';
      5 : PV := 'Paradox 5.X;';
      7 : PV := 'Paradox 7.X;';
 End;
 if SS[Length(SS)]=',' Then Borland.Delphi.System.Delete(SS,Length(SS),1);
 SQL := TStringList.Create;
 Try
   SQL.Add(Format('Select %s INTO [%s] IN "%s"[%s] FROM [%s]',[SS,FN,FP,PV,TN]));
   if (Table.Filtered) And (Table.Filter <> '') Then SQL.Add(' WHERE '+Table.Filter);
   SQL.Add(';');
 Finally
   SQL.Free;
 End;
 Finally
   Table.Connection.ConnectionObject.Execute(SQL.Text,RA,0);
 End;
End;

Procedure TSAS.AccessExportToDBase(FileName:String; DBaseVersion:Integer; DeleteOld:Boolean);
Var
 SQL : TStringList;
 FN  : String;
 FP  : String;
 SS  : String;
 X   : Integer;
 FC  : Integer;
 DV  : String;
 P   : Integer;
 Res : Integer;
 Dir : TSearchRec;
 TN  : String;
 RA  : OleVariant;
Begin
 If Not Table.Active Then DatabaseError('Table must be open in order to export data!');
 TN := '';
 TN := Table.TableName;
 FN := ExtractFileName(FileName);
 FP := ExtractFilePath(FileName);
 if (DeleteOld) Then
    Begin
     P := FN.LastIndexOf('.');
     if P > -1 Then  FN := Borland.Delphi.System.Copy(FN,1,P);
     Res := Borland.Vcl.SysUtils.FindFirst(FP+FN+'.*',faArchive,Dir);
     While Res = 0 Do
       Begin
         DeleteFile(FP+Dir.Name);
         Res:= Borland.Vcl.SysUtils.FindNext(Dir);
       End;
     Borland.Vcl.SysUtils.FindClose(Dir);
    End;
 FN := ExtractFileName(FileName);
 if FP='' Then FP:='.';
 SS:='';
 FC := Table.FieldCount-1;
 For X := 0 To FC do
     Begin
      if StoreField(X) Then
       Begin
        if UseBrackets Then
          Begin
           SS := SS+' '+BracketField(Table.Fields[X].FieldName);
           if X < FC Then SS := SS+','
          End
        Else
          Begin
           if X < FC Then
              SS := SS+' '+Table.Fields[X].FieldName+','
           Else
              SS := SS+' '+Table.Fields[X].FieldName;
          End;
       End;
     End;
 Case DBaseVersion of
      3 : DV := 'dBase III;';
      4 : DV := 'dBase IV;';
      5 : DV := 'dBase 5.0;';
 End;
 if SS[Length(SS)]=',' Then Borland.Delphi.System.Delete(SS,Length(SS),1);
 SQL := TStringList.Create;
 Try
   SQL.Add(Format('Select %s INTO [%s] IN "%s"[%s] FROM [%s]',[SS,FN,FP,DV,TN]));
   if (Table.Filtered) And (Table.Filter <> '') Then SQL.Add(' WHERE '+Table.Filter);
   SQL.Add(';');
   Table.Connection.ConnectionObject.Execute(SQL.Text,RA,0);
 Finally
   SQL.Free;
 End;
End;


Procedure TSAS.AccessExportToMDB(FileName,NewTableName:String; DeleteOld:Boolean);
Var
 SQL : TStringList;
 SS  : String;
 X   : Integer;
 FC  : Integer;
 TN  : String;
 RA  : OleVariant;
Begin
 If Not Table.Active Then DatabaseError('Table must be open in order to export data!');
 TN := '';
 Try
 if (DeleteOld) Then
     Begin
       SQL := TStringList.Create;
       Try
        SQL.Add('DROP TABLE ['+FileName+'].['+NewTableName+'];');
        Table.Connection.ConnectionObject.Execute(SQL.Text,RA,0);
       Except
       End;
       SQL.Free;
     End;
 TN := Table.TableName;
 SS:='';
 FC := Table.FieldCount-1;
 For X := 0 To FC do
     Begin
     if StoreField(X) Then
       Begin
        if UseBrackets Then
          Begin
           SS := SS+' '+BracketField(Table.Fields[X].FieldName);
           if X < FC Then SS := SS+','
          End
        Else
          Begin
           if X < FC Then
              SS := SS+' '+Table.Fields[X].FieldName+','
           Else
              SS := SS+' '+Table.Fields[X].FieldName;
          End;
       End;
     End;
 if SS[Length(SS)]=',' Then Borland.Delphi.System.Delete(SS,Length(SS),1);
 SQL := TStringList.Create;
 Try
   SQL.Add(Format('Select %s INTO [%s].[%s] FROM [%s]',[SS,FileName,NewTableName,TN]));
   if (Table.Filtered) And (Table.Filter <> '') Then SQL.Add(' WHERE '+Table.Filter);
   SQL.Add(';');
   Table.Connection.ConnectionObject.Execute(SQL.Text,RA,0);
 Finally
   SQL.Free;
 End;
 Finally
 End;
End;

Procedure TSAS.SaveToADTG(const FileName: String; DeleteExisting:Boolean);
Var
  BK       : TObject;
  S        : String;
  IsRemote : Boolean;
  Data     : TObject;
  NB       : Integer;
Begin
  if Not Table.Active Then DatabaseError('Cannot save to ADTG while table is not open!');
  if (NOT (csDestroying in ComponentState)) And (Table.IsEmpty) Then DatabaseError('Cannot save to ADTG while table empty!');
  if DeleteExisting Then DeleteFile(FileName);
  if (NOT (csDestroying in ComponentState)) Then Table.CheckBrowseMode;
  Table.SaveToFile(FileName,pfADTG);
End;

Procedure TSAS.SaveToXML(const FileName: String; DeleteExisting:Boolean);
Var
  BK       : TObject;
  S        : String;
  IsRemote : Boolean;
  Data     : TObject;
  NB       : Integer;
Begin
  if Not Table.Active Then DatabaseError('Cannot save to ADTG while table is not open!');
  if (NOT (csDestroying in ComponentState)) And (Table.IsEmpty) Then DatabaseError('Cannot save to ADTG while table empty!');
  if DeleteExisting Then DeleteFile(FileName);
  if (NOT (csDestroying in ComponentState)) Then Table.CheckBrowseMode;
  Table.SaveToFile(FileName,pfXML);
End;

Function TSAS.CreateAccessDatabaseEx(DatabaseName, Language, DatabasePassword, Version: String; Encrypt: Boolean):Boolean;
Var
  S       : String;
  Cat     : System.Type;
  CatCom  : TObject;
  ConnCom : TObject;
  Params  : array[0..0] of TObject;
  Res     : TObject;
Begin
Result := False;
 Try
  Cat     := System.Type.GetTypeFromProgID('ADOX.Catalog');
  CatCom  := Activator.CreateInstance(Cat);
  Try
    S:='Provider=Microsoft.Jet.OLEDB.4.0;';
    S:=S+'Data Source='+DatabaseName;
    if Language <> '' Then  S := S+';Locale Identifier='+Language;
    if Version  <> '' Then  S := S+';Jet OLEDB:Engine Type='+Version;
    if DatabasePassword <> '' Then  S := S+';Jet OLEDB:Database Password="'+DatabasePassword+'"';
    if Encrypt        Then  S := S+';Jet OLEDB:Encrypt Database=True';
    Params[0] := S;
    ConnCom   := Cat.InvokeMember('Create', BindingFlags.InvokeMethod, nil, CatCom, Params);
    ConnCom   := Cat.InvokeMember('ActiveConnection', BindingFlags.GetProperty, nil, CatCom, Nil);
    if Assigned(ConnCom) Then
       Begin
         Res    := ConnCom.GetType.InvokeMember('Close', BindingFlags.InvokeMethod, Nil, ConnCom, Nil);
       End;
    Result    := True;
  Finally
    ConnCom   := Nil;
    CatCom.Free;
    Cat.Free;
    CatCom := Nil;
    Cat    := Nil;
  End;
 Except
 End;
End;

Function TSAS.CreateAccessDatabase(DatabaseName: String):Boolean;
begin
  Result := CreateAccessDatabaseEx(DatabaseName,'','','',False);
end;


procedure TSAS.DoExport;
Var
  II           : Integer;
  FileName     : String;
  SheetName    : String;
  DeleteOld    : Boolean;
begin
  II := ListBox1.ItemIndex;
  if II = -1  Then Exit;
  FileName   :=  SaveDialog1.FileName;
  if FileName = '' Then Exit;
  SheetName  := Edit2.Text;
  DeleteOld  := CheckBox2.Checked;

  Case II of
      0 : Begin
           if SheetName = '' Then Exit;
           AccessExportToExcel(FileName, SheetName, 3, DeleteOld);
          End;
      1 : Begin
           if SheetName = '' Then Exit;
           AccessExportToExcel(FileName, SheetName, 4, DeleteOld);
          End;
      2 : Begin
           if SheetName = '' Then Exit;
           AccessExportToExcel(FileName, SheetName, 5, DeleteOld);
          End;
      3 : Begin
           if SheetName = '' Then Exit;
           AccessExportToExcel(FileName, SheetName, 8, DeleteOld);
          End;
      4 : Begin
           AccessExportToParadox(FileName, 3, DeleteOld);
          End;
      5 : Begin
            AccessExportToParadox(FileName, 4, DeleteOld);
          End;
      6 : Begin
            AccessExportToParadox(FileName, 5, DeleteOld);
          End;
      7 : Begin
            AccessExportToParadox(FileName, 7, DeleteOld)
          End;
      8 : Begin
            AccessExportToDBase(FileName, 3, DeleteOld);
          End;
      9 : Begin
            AccessExportToDBase(FileName, 4, DeleteOld);
          End;
      10: Begin
            AccessExportToDBase(FileName, 5, DeleteOld);
          End;
      11: Begin
            AccessExportToHTML(FileName, DeleteOld);
            WriteSchemaIni(FileName);
            AccessExportToHTML(FileName, True);
          End;
      12: Begin
            AccessExportToTXT(FileName, True);
            WriteSchemaIni(FileName);
            AccessExportToTXT(FileName, DeleteOld);
          End;
      13: Begin
            if Not FileExists(FileName) Then
               Begin
                 CreateAccessDatabase(FileName);
                 DeleteOld := False;
               End;
            AccessExportToMDB(FileName, Edit3.Text, DeleteOld);
          End;
      14: Begin
            SaveToXML(FileName,True);
          End;
      15: Begin
            SaveToADTG(FileName,True);
          End;
  End;
  ModalResult := mrOK;
end;

procedure TSAS.Button2Click(Sender: TObject);
begin
 ModalResult := mrCancel;
end;

procedure TSAS.Button1Click(Sender: TObject);
Var
  II           : Integer;
  X            : Integer;
  FF           : TField;
  Column       : TColumn;
begin
  II := ListBox1.ItemIndex;
  if II = -1  Then Exit;
  SaveDialog1.Options := SaveDialog1.Options+[ofPathMustExist,ofOverwritePrompt];
  Case II of
      0 : Begin
           SaveDialog1.DefaultExt:='xls';
           SaveDialog1.Filter:='MS Excel 3.0 files(*.xls)|*.xls|All files (*.*)|*.*';
           SaveDialog1.FilterIndex:=1;
          End;
      1 : Begin
           SaveDialog1.DefaultExt:='xls';
           SaveDialog1.Filter:='MS Excel 4.0 files (*.xls)|*.xls|All files (*.*)|*.*';
           SaveDialog1.FilterIndex:=1;
          End;
      2 : Begin
           SaveDialog1.DefaultExt:='xls';
           SaveDialog1.Filter:='MS Excel 5.0 files (*.xls)|*.xls|All files (*.*)|*.*';
           SaveDialog1.FilterIndex:=1;
          End;
      3 : Begin
           SaveDialog1.DefaultExt:='xls';
           SaveDialog1.Filter:='MS Excel 8.0 files (*.xls)|*.xls|All files (*.*)|*.*';
           SaveDialog1.FilterIndex:=1;
          End;
      4 : Begin
           SaveDialog1.DefaultExt:='db';
           SaveDialog1.Filter:='Paradox 3.0 files (*.db)|*.db|All files (*.*)|*.*';
           SaveDialog1.FilterIndex:=1;
          End;
      5 : Begin
            SaveDialog1.DefaultExt:='db';
           SaveDialog1.Filter:='Paradox 4.0 files (*.db)|*.db|All files (*.*)|*.*';
           SaveDialog1.FilterIndex:=1;
          End;
      6 : Begin
           SaveDialog1.DefaultExt:='db';
           SaveDialog1.Filter:='Paradox 5.0 files (*.db)|*.db|All files (*.*)|*.*';
           SaveDialog1.FilterIndex:=1;
          End;
      7 : Begin
            SaveDialog1.FilterIndex:=1;
            SaveDialog1.DefaultExt:='db';
            SaveDialog1.Filter:='Paradox 7.0 files(*.db)|*.db|All files (*.*)|*.*'
          End;
      8 : Begin
            SaveDialog1.DefaultExt:='dbf';
            SaveDialog1.Filter:='dBase III files(*.dbf)|*.dbf|All files (*.*)|*.*';
            SaveDialog1.FilterIndex:=1;
          End;
      9 : Begin
            SaveDialog1.DefaultExt:='dbf';
            SaveDialog1.Filter:='dBase IV files(*.dbf)|*.dbf|All files (*.*)|*.*';
            SaveDialog1.FilterIndex:=1;
          End;
      10: Begin
            SaveDialog1.DefaultExt:='dbf';
            SaveDialog1.Filter:='dBase 5.0 files(*.dbf)|*.dbf|All files (*.*)|*.*';
            SaveDialog1.FilterIndex:=1;
          End;
      11: Begin
            SaveDialog1.DefaultExt:='htm';
            SaveDialog1.Filter:='HTML files(*.htm)|*.htm|All files (*.*)|*.*';
            SaveDialog1.FilterIndex:=1;
          End;
      12: Begin
            SaveDialog1.DefaultExt:='txt';
            SaveDialog1.Filter:='Text files(*.txt)|*.txt|All files (*.*)|*.*';
            SaveDialog1.FilterIndex:=1;
          End;
      13: Begin
            SaveDialog1.DefaultExt:='mdb';
            SaveDialog1.Filter:='MS Access files(*.mdb)|*.mdb|All files (*.*)|*.*';
            SaveDialog1.FilterIndex:=1;
          End;
      14: Begin
            SaveDialog1.DefaultExt:='xml';
            SaveDialog1.Filter:='XML files(*.xml)|*.xml|All files (*.*)|*.*';
            SaveDialog1.FilterIndex:=1;
          End;
      15: Begin
            SaveDialog1.DefaultExt:='adt';
            SaveDialog1.Filter:='ADTG files(*.adt)|*.adt|All files (*.*)|*.*';
            SaveDialog1.FilterIndex:=1;
          End;
  End;
  if ExportDir <> '' Then SaveDialog1.InitialDir := ExportDir;
  if SaveDialog1.Execute Then
     Begin
       Try
        For X := 0 to CheckListBox1.Items.Count-1 do
            Begin
              if NOT CheckListBox1.Checked[X] Then
                 Begin
                   if Grid <> Nil Then
                      Begin
                        Column := FindColumn(CheckListBox1.Items.Strings[X]);
                        if Column <> Nil Then Column.Field.Visible := False;
                      End
                   Else
                      Begin
                       FF := FindCaption(CheckListBox1.Items.Strings[X]);
                       if FF <> Nil Then FF.Visible:=False;
                      End;
                 End;
             End;
        DoExport;
       Finally
         For X := 0 to CheckListBox1.Items.Count-1 do                             
             Begin
              if Grid <> Nil Then
                 Begin
                   Column := FindColumn(CheckListBox1.Items.Strings[X]);
                   if Column <> Nil Then Column.Field.Visible := True;
                 End
              Else
                 Begin
                   FF := FindCaption(CheckListBox1.Items.Strings[X]);
                   if FF <> Nil Then FF.Visible:=True;
                 End;
             End;
       End;
     End;
end;

procedure TSAS.ComboBox2Change(Sender: TObject);
begin
 if ComboBox2.ItemIndex=3  Then Edit1.Visible:=True Else Edit1.Visible:=False;
end;

end.

