unit KA.Data.Ado.SelectIndexUnit;
interface

uses
  System.Runtime.InteropServices,
  Borland.Vcl.SysUtils,
  Borland.Vcl.Classes,
  Borland.Vcl.Controls,
  Borland.Vcl.Forms,
  Borland.Vcl.Dialogs,
  Borland.Vcl.StdCtrls,
  Borland.Vcl.Grids,
  Borland.Vcl.ADODB,
  Borland.Vcl.ADOInt,
  System.ComponentModel;

type
  TAdoSelectIndex = class(TForm)
    Label1: TLabel;
    StringGrid1: TStringGrid;
    ComboBox1: TComboBox;
    Button1: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
    procedure ComboBox1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    Database  : TAdoConnection;
    Table     : TAdoTable;
    Procedure GetFieldsInIndex(List:TStrings;Const TableName,IndexName : String);
  public
    { Public declarations }
    Function Execute(AdoTable : TAdoTable; Var IndexName:String):Boolean;
  end;


var
  AdoSelectIndex: TAdoSelectIndex;

implementation
Uses
  Borland.Vcl.Variants;

{$R *.nfm}

Const
  EmtyIndex    : String = 'Don''t use an Index';
  dbDescending : Integer = 1;

function OleVarDataToVariant(OleVarData: TOleVarData): Variant;
var
  Buffer: IntPtr;
begin
  Buffer := Marshal.AllocHGlobal(Marshal.SizeOf(TypeOf(TOleVarData)));
  try
    Marshal.StructureToPtr(OleVarData, Buffer, False);
    Result := Variant(Marshal.GetObjectForNativeVariant(Buffer));
  finally
    Marshal.FreeHGlobal(Buffer);
  end;
end;


Function TAdoSelectIndex.Execute(AdoTable : TAdoTable;Var IndexName:String):Boolean;
Var
 S : String;
Begin
 Result   := False;
 Table    := AdoTable;
 Database := AdoTable.Connection;
 ComboBox1.Clear;
 AdoTable.GetIndexNames(ComboBox1.Items);
 ComboBox1.Items.Insert(0,EmtyIndex);
 ComboBox1.ItemIndex:=ComboBox1.Items.IndexOf(IndexName);
 if ComboBox1.ItemIndex=-1 Then ComboBox1.ItemIndex := 0;
 StringGrid1.ColWidths[0]:=((StringGrid1.Width-5) div 2);
 StringGrid1.ColWidths[1]:=StringGrid1.ColWidths[0];
 StringGrid1.Cells[0,0]:='Field Name';
 StringGrid1.Cells[1,0]:='Sort Order';
 StringGrid1.RowCount:=2;
 StringGrid1.Rows[1].Clear;
 ComboBox1Change(ComboBox1);
 ShowModal;
 if ModalResult=mrOK Then
    Begin
      Result    := True;
      S         := ComboBox1.Items[ComboBox1.ItemIndex];
      if S = EmtyIndex Then S := '';
      IndexName := S;
    End;
End;

Procedure TAdoSelectIndex.GetFieldsInIndex(List:TStrings;Const TableName,IndexName : String);
Var
  RS      : Recordset;
  FieldN  : String;
  Col     : Integer;
Begin
  List.Clear;
  if (NOT Assigned(Database)) Or (Not Database.Connected) Then Exit;
  RS := CoRecordset._Create;
  Try
    RS := Database.ConnectionObject.OpenSchema(adSchemaIndexes,VarArrayOf([Unassigned, Unassigned, IndexName, Unassigned, TableName]), EmptyParam);
    if (NOT RS.BOF) And (NOT RS.EOF) Then
       Begin
        RS.MoveFirst;
        While NOT RS.EOF do
           Begin
             FieldN := VarAsType(OleVarDataToVariant(RS.Fields.Item['COLUMN_NAME'].Value),VarString);
             Col    := VarAsType(OleVarDataToVariant(RS.Fields.Item['COLLATION'].Value),VarInteger);
             if Col=1 Then
                List.AddObject(FieldN,TObject(False))
             Else
                List.AddObject(FieldN,TObject(True));
             RS.MoveNext;
           End;
       End;
    RS.Close;
  Except
  End;
  RS := Nil;
End;

procedure TAdoSelectIndex.ComboBox1Change(Sender: TObject);
Var
  SL   : TStringList;
  RC   : Integer;
  X    : Integer;
  S    : String;
begin
 StringGrid1.RowCount:=2;
 StringGrid1.Rows[1].Clear;
 if ComboBox1.ItemIndex<>-1 Then
    Begin
      S:= ComboBox1.Items[ComboBox1.ItemIndex];
      if S=EmtyIndex Then S := '';
      If CheckBox1.Checked Then Table.IndexName := S;
      if S <> '' Then
         Begin
           SL    := TStringList.Create;
           Try
             GetFieldsInIndex(SL,Table.TableName,S);
             RC := SL.Count;
             if RC=0 Then RC := 1;
             StringGrid1.RowCount := RC+1;
             For X := 0 To SL.Count-1 do
                 Begin
                    StringGrid1.Cells[0,X+1] := SL.Strings[X];
                    If SL.Objects[X]=TObject(True) Then
                       StringGrid1.Cells[1,X+1]:='Descending'
                    Else
                       StringGrid1.Cells[1,X+1]:='Ascending';
                 End;
           Finally
             SL.Free;
           End;
         End;
    End;
End;

procedure TAdoSelectIndex.Button2Click(Sender: TObject);
begin
 ModalResult := mrCancel;
end;

procedure TAdoSelectIndex.Button1Click(Sender: TObject);
begin
 ModalResult := mrOK;
end;



end.
